---
title: MessageChannel.port1
slug: Web/API/MessageChannel/port1
tags:
  - API
  - Channel messaging
  - HTML5
  - Message Channel API
  - MessageChannel
  - Property
  - Reference
---
<div>{{APIRef("HTML DOM")}}</div>

<p>The <code><strong>port1</strong></code> read-only property of the {{domxref("MessageChannel")}} interface returns the first port of the message channel — the port attached to the context that originated the channel.</p>

<p>{{AvailableInWorkers}}</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">channel.port1;</pre>

<h3 id="Value">Value</h3>

<p>A {{domxref("MessagePort")}} object, the first port of the channel, that is the port attached to the context that originated the channel.</p>

<h2 id="Example">Example</h2>

<p>In the following code block, you can see a new channel being created using the {{domxref("MessageChannel.MessageChannel", "MessageChannel()")}} constructor. When the {{HTMLElement("iframe")}} has loaded, we pass {{domxref("MessageChannel.port2")}} to the {{HTMLElement("iframe")}} using {{domxref("MessagePort.postMessage")}} along with a message. The <code>handleMessage</code> handler then responds to a message being sent back from the <code>&lt;iframe&gt;</code> (using {{domxref("MessagePort.onmessage")}}), putting it into a paragraph. The <code>handleMessage</code> method is associated to the <code>port1</code> to listen when the message arrives.</p>

<pre class="brush: js highlight[13]">var channel = new MessageChannel();
var para = document.querySelector('p');

var ifr = document.querySelector('iframe');
var otherWindow = ifr.contentWindow;

ifr.addEventListener("load", iframeLoaded, false);

function iframeLoaded() {
  otherWindow.postMessage('Hello from the main page!', '*', [channel.port2]);
}

channel.port1.onmessage = handleMessage;
function handleMessage(e) {
  para.innerHTML = e.data;
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('HTML WHATWG', 'web-messaging.html#dom-messagechannel-port1', 'port1')}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.MessageChannel.port1")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Channel_Messaging_API/Using_channel_messaging">Using channel messaging</a></li>
</ul>
